#!/usr/bin/python3

import sys
import json
import time
import datetime
import i3ipc

sway = i3ipc.Connection()
out_format = "%Y-%m-%d %H:%M:%S"

if len(sys.argv) > 1:
    out_format = sys.argv[1]

def on_tick(sway, event):
    s = json.dumps({
        "text": datetime.datetime.now().strftime(out_format),
        "tooltip": datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")
    })

    print(s, file=sys.stdout)
    sys.stdout.flush()

    time.sleep(1)
    sway.send_tick()

def on_shutdown(sway, event):
    sway.main_quit()

sway.on(i3ipc.Event.TICK,             on_tick)
sway.on(i3ipc.Event.SHUTDOWN,         on_shutdown)
sway.on(i3ipc.Event.SHUTDOWN_RESTART, on_shutdown)
sway.on(i3ipc.Event.SHUTDOWN_EXIT,    on_shutdown)
sway.on(i3ipc.Event.BARCONFIG_UPDATE, on_shutdown)
sway.send_tick()
sway.main()
